#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2200three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 2200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2200three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three22004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three22004xi = {
                1:'0x2135y-528z',
                2:'1001x1668y-1025z',
                3:'104x217y-2186z',
                4:'1072x1481y-1223z',
                5:'1088x1885y-313z',
                6:'1093x1622y-1005z',
                7:'1094x1751y-756z',
                8:'112x2137y-507z',
                9:'113x90y-2195z',
                10:'1156x1432y-1204z',
                11:'1182x1571y-986z',
                12:'1187x1828y-291z',
                13:'1189x1698y-735z',
                14:'122x591y-2115z',
                15:'1237x1378y-1186z',
                16:'1269x1514y-966z',
                17:'126x230y-2184z',
                18:'127x1842y-1196z',
                19:'1280x1639y-715z',
                20:'1283x1766y-269z',
                21:'1316x1320y-1167z',
                22:'1353x1453y-946z',
                23:'1369x1575y-694z',
                24:'136x96y-2193z',
                25:'1375x1698y-247z',
                26:'1392x1257y-1149z',
                27:'1434x1386y-926z',
                28:'1454x1506y-673z',
                29:'1464x1190y-1130z',
                30:'1464x1626y-225z',
                31:'149x242y-2181z',
                32:'14x108y-2197z',
                33:'1512x1315y-906z',
                34:'1534x1118y-1111z',
                35:'1536x1432y-652z',
                36:'1548x1548y-203z',
                37:'1585x1240y-886z',
                38:'158x604y-2109z',
                39:'1614x1354y-631z',
                40:'1629x1467y-181z',
                41:'1655x1160y-866z',
                42:'1688x1272y-610z',
                43:'1705x1380y-160z',
                44:'173x1981y-939z',
                45:'174x1688y-1399z',
                46:'174x252y-2178z',
                47:'1757x1185y-588z',
                48:'1776x1290y-138z',
                49:'196x615y-2103z',
                50:'1x65y-2199z',
                51:'200x259y-2175z',
                52:'20x28y-2199z',
                53:'224x2133y-486z',
                54:'225x1844y-1177z',
                55:'228x265y-2171z',
                56:'235x623y-2096z',
                57:'24x129y-2196z',
                58:'256x268y-2168z',
                59:'25x539y-2132z',
                60:'264x1690y-1382z',
                61:'276x629y-2089z',
                62:'278x1979y-919z',
                63:'286x269y-2164z',
                64:'316x268y-2160z',
                65:'318x633y-2082z',
                66:'31x1834y-1214z',
                67:'323x1841y-1158z',
                68:'336x2123y-464z',
                69:'347x264y-2156z',
                70:'355x1687y-1365z',
                71:'361x633y-2075z',
                72:'36x149y-2194z',
                73:'36x44y-2199z',
                74:'378x258y-2151z',
                75:'383x1970y-899z',
                76:'404x631y-2068z',
                77:'422x1833y-1140z',
                78:'447x1680y-1348z',
                79:'448x2107y-443z',
                80:'449x626y-2060z',
                81:'487x1956y-878z',
                82:'494x617y-2052z',
                83:'50x167y-2193z',
                84:'520x1819y-1121z',
                85:'538x1667y-1330z',
                86:'539x606y-2044z',
                87:'53x58y-2198z',
                88:'558x2085y-421z',
                89:'55x558y-2127z',
                90:'585x591y-2036z',
                91:'592x1936y-858z',
                92:'618x1800y-1102z',
                93:'629x1648y-1313z',
                94:'630x574y-2028z',
                95:'668x2057y-399z',
                96:'66x185y-2191z',
                97:'675x553y-2019z',
                98:'695x1911y-838z',
                99:'69x1978y-958z',
                100:'716x1775y-1083z',
                101:'719x529y-2010z',
                102:'720x1625y-1295z',
                103:'72x70y-2197z',
                104:'762x501y-2001z',
                105:'776x2023y-378z',
                106:'797x1879y-818z',
                107:'7x10y-2199z',
                108:'7x87y-2198z',
                109:'810x1597y-1277z',
                110:'812x1745y-1064z',
                111:'84x202y-2189z',
                112:'87x575y-2121z',
                113:'882x1983y-356z',
                114:'898x1842y-797z',
                115:'899x1563y-1259z',
                116:'89x1757y-1480z',
                117:'908x1709y-1044z',
                118:'92x81y-2196z',
                119:'986x1524y-1241z',
                120:'987x1937y-334z',
                121:'997x1800y-777z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2200three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire2200three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2200THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2200THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2200THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2200THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2200THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three22004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2200THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2200THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2200THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three22004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three<8shot2three22004xi/nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2200THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2200THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2200THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2200three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                